#include "mbed.h"
#include <cstdint>

Timer tmr;
uint32_t value;

void myfun()
{
	// stop the timer and read the value, then reset
	tmr.stop();
	value = tmr.read_us();
	tmr.reset();
	return;
}

int main()
{
	// initialize value
	value = 0;
	// Create the sensor
	DigitalInOut sensor(p21);

	// Output a 2us pulse
	sensor.output();
	sensor.write(1);
	wait_us(2);
	sensor.write(0);
	// Start the timer
	tmr.start();
	// Reconfigure as input (Is this necessary?)
	sensor.input();
	// Configure as interrupt input and set up function
	InterruptIn sensorInterrupt(p21);
	sensorInterrupt.fall(&myfun);

	// Wait until value is changed
	while(value == 0); // My code never gets past here
	
	// I have other code here
	
	return 0;
}
